/* Se citeste n, apoi numele si media a n copii
    Sa se afiseze copiii in ordine descrescatoare dupa medie
    si la aceeasi medie, lexicografic dupa nume
*/
#include <fstream>
#include <algorithm>

struct Elev {
    std::string nume;
    double media;

    bool operator < (const Elev& e) const
    {
        return media > e.media ||
               (media == e.media && nume < e.nume);
    }
};

void CitesteElevii(Elev e[], int& n);
void SorteazaElevii(Elev e[], int n);
void AfiseazaElevii(Elev e[], int n, std::ofstream& fout);

int main()
{
    Elev e[1000];
    int n;
    std::ofstream fout;
    fout.open("elevi.out");
    CitesteElevii(e, n);
    AfiseazaElevii(e, n, fout);
    sort(e + 1, e + n + 1);
    AfiseazaElevii(e, n, fout);

    fout.close();
    return 0;
}

void CitesteElevii(Elev e[], int& n)
{
    std::ifstream fin("elevi.in");

    fin >> n;
    for (int i = 1; i <= n; ++i)
        fin >> e[i].nume >> e[i].media;
    fin.close();
}

void AfiseazaElevii(Elev e[], int n, std::ofstream& fout)
{
    for (int i = 1; i <= n; ++i)
        fout << e[i].nume << ' '
             << e[i].media << '\n';
    fout << "\n\n";
}
