/* Se citeste n, apoi numele si media a n copii
    Sa se afiseze copiii in ordine descrescatoare dupa medie
    si la aceeasi medie, lexicografic dupa nume
*/
#include <fstream>
#include <algorithm>
#include <vector>

struct Elev {
    std::string nume;
    double media;

    bool operator < (const Elev& e) const
    {
        return media > e.media ||
               (media == e.media && nume < e.nume);
    }
};

void CitesteElevii(std::vector<Elev>& e);
void AfiseazaElevii(std::vector<Elev>& e, std::ofstream& fout);

int main()
{
    std::vector<Elev> e;
    std::ofstream fout;
    fout.open("elevi.out");
    CitesteElevii(e);
    AfiseazaElevii(e, fout);
    sort(e.begin(), e.end());
    AfiseazaElevii(e, fout);

    fout.close();
    return 0;
}

void CitesteElevii(std::vector<Elev>& e)
{
    std::ifstream fin("elevi.in");
    int n;
    fin >> n;
    std::string nume;
    double media;
    for (int i = 0; i < n; ++i)
    {
        fin >> nume >> media;
        e.push_back({nume, media});
    }
    fin.close();
}

void AfiseazaElevii(std::vector<Elev>& e, std::ofstream& fout)
{
    for (int i = 0; i < e.size(); ++i)
        fout << e[i].nume << ' '
             << e[i].media << '\n';
    fout << "\n\n";
}
